#include <SDL.h>
#include <SDL_image.h>
#include <iostream>

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Renderer *renderer;
    SDL_Texture *textura;
    SDL_Texture *textura2;
    Uint32 formato;
    SDL_Rect origen = {100,107,25,25};
    SDL_Rect destino = {0,0,200,200};
    SDL_Point centro = {100,100};

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow("Mi primera ventana",
        SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS);
    renderer = SDL_CreateRenderer(ventana, -1, 0);
    textura = IMG_LoadTexture(renderer, "loroscolor.png");
    SDL_RenderSetScale(renderer, 1.1, 1.1);
    SDL_QueryTexture(textura, &formato, NULL, NULL, NULL);
    textura2 = SDL_CreateTexture(renderer, formato, SDL_TEXTUREACCESS_TARGET, 200, 200);

    SDL_SetTextureScaleMode(textura, SDL_ScaleModeNearest);
    std::cout << "ScaleModeNearest" << std::endl;
    SDL_SetRenderTarget(renderer, textura2);
    SDL_RenderCopyEx(renderer, textura, &origen, &destino, 1.0, &centro, SDL_FLIP_NONE);
    SDL_SetRenderTarget(renderer, NULL);
    SDL_RenderCopy(renderer, textura2, NULL, &destino);
    SDL_RenderPresent(renderer);
SDL_Delay(1000);

    SDL_SetTextureScaleMode(textura, SDL_ScaleModeLinear);
    std::cout << "ScaleModeLinear" << std::endl;
    SDL_SetRenderTarget(renderer, textura2);
    SDL_RenderCopyEx(renderer, textura, &origen, &destino, 1.0, &centro, SDL_FLIP_NONE);
    SDL_SetRenderTarget(renderer, NULL);
    destino.x=240;
    SDL_RenderCopy(renderer, textura2, NULL, &destino);
    SDL_RenderPresent(renderer);
SDL_Delay(1000);

    SDL_SetTextureScaleMode(textura, SDL_ScaleModeBest);
    std::cout << "ScaleModeBest" << std::endl;
    destino.x=0;
    SDL_SetRenderTarget(renderer, textura2);
    SDL_RenderCopyEx(renderer, textura, &origen, &destino, 1.0, &centro, SDL_FLIP_NONE);
    destino.x=240;
    destino.y=240;
    SDL_SetRenderTarget(renderer, NULL);
    SDL_RenderCopy(renderer, textura2, NULL, &destino);
    SDL_RenderPresent(renderer);
SDL_Delay(1000);

    std::cout << SDL_SetTextureScaleMode(textura, SDL_ScaleModeLinear) << std::endl;
    destino.x=0;
    destino.y=240;
    SDL_RenderCopyEx(renderer, textura, &origen, &destino, 15.0, &centro, SDL_FLIP_NONE);
    SDL_RenderPresent(renderer);


SDL_Delay(8000);

    SDL_DestroyTexture(textura2);
    SDL_DestroyTexture(textura);
    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}
